// JavaScript Document
// JavaScript Document
if (!ADMONITOR) var ADMONITOR = {};

ADMONITOR.historybrowser= function() {
    var urlList = [];
    var resultArray = null;
    var account = null;
    var startUrl = 'https://www.google.com/history/lookup?month=1&day=1&yr=2011&num=10000';
      
    function _initHistIFrame() {
	    var hist_frame = document.createElement("iframe"); // iframe or browser
	    hist_frame.setAttribute("id", "history-frame");
  		hist_frame.setAttribute("name", "history-frame");
  		hist_frame.setAttribute("type", "content");
  		hist_frame.style.setProperty('min-height', "0px", 'important');
  		hist_frame.style.setProperty('height', "0px", 'important');
  		document.getElementById("main-window").appendChild(hist_frame);
      hist_frame.docShell.allowAuth = true;
  		hist_frame.docShell.allowImages = true;
  		hist_frame.docShell.allowJavascript = true;
  		hist_frame.docShell.allowMetaRedirects = true;
  		hist_frame.docShell.allowPlugins = true;
  		hist_frame.docShell.allowSubframes = true;
  		
  		hist_frame.addEventListener("load", function (event) {
    		var frame = document.getElementById("history-frame")  		
    		var doc = event.originalTarget;
    		
    		if (doc.location.href.indexOf("https://www.google.com/accounts/b/0/Reauthenticate") == 0) {
                  alert('Please relog in Google (visit google.com/history) and restart ADMONITOR/History');
                  return;
        }
        _cout('Loaded : '+doc.location.href)
    	//	if (doc.location.href == "about:blank" || doc.defaultView.frameElement) return;     
        var month = _getMonth(doc);
        var hist = _exctractHistory(doc);        
    	//	_writeHistfile(hist,month);
    		//_cout('Wrote history for month: '+month)
    		var next_ =  _getNext(doc);
    		if(next_!=null)
    		  setTimeout(_goToNext,5000,frame,next_);
    		 else {
    		         //alert("Done extrating the search history.\n Starting the attack.")
                 ADMONITOR.main._init();
                 return;

         }
  		}, true); 
      
      return hist_frame;   	        
    } 
    
    
    function _cout(msg) {
      	ADMONITOR.utils._cout(msg);
  	} 
  	
  	function _goToNext(frame,next_) {
  	    _cout('Location is : '+frame.contentDocument.location.href)
  	   _cout('Next is :'+'https://www.google.com/history/'+next_)
  	   resultArray.start = 'https://www.google.com/history/'+next_;
        frame.contentDocument.location.href = 'https://www.google.com/history/'+next_;
    }
    
    function upSearchAndClickNodes(table) {
    _cout('Entered: upSearchAndClickNodes')
        var anchors_ = table.getElementsByTagName('a');
        var clone = null;
        if(anchors_.length==0){
           if (table.getElementsByTagName('b').length ==0 ||
              (table.getElementsByTagName('b')[0].innerHTML.indexOf('cont') >0)) 
             table.innerHTML = '';
           else  table.innerHTML += '<br>';       
           return;  
        }
        for ( var i=0; i<anchors_.length; i++) {
            var anch = anchors_[i];
            if (!anch.hasAttribute('onclick') ) { // Not a Viewed ...
                if (anch.getAttribute('href').indexOf('http://') == 0 ){ //This is a search
                  table.appendChild(anch.parentNode.previousSibling.cloneNode(true))
                  table.appendChild(anch.parentNode.cloneNode(true))
                } else {
                  table.appendChild(anch.parentNode.cloneNode(true))
                }
                table.removeChild(table.childNodes[1]);
                table.innerHTML += '<br>'
                return;
            }
        }
        
     }
  	
  	function extractHistoryFromDoc(doc, adElement) {
  	    var month = _getMonth( doc );
  	    //if(!month) return;
  	    if (!account) {
           account = _exctractAccountName( doc );
           resultArray.account = account;
        } 
  	    for (var i=0; i< 10000; i++) {
          var res = doc.querySelector('#r'+i);
          if (!res) return;
                    _cout('res  '+res.textContent)
          for (var j=0; j< 10000; j++) {
            var clic = doc.querySelector('#bkmk_href_'+i+'-'+j);
            if (!clic) break;
            var url = clic.getAttribute('title');
            _cout(url)
            if (resultArray.array.indexOf(url) < 0 ) {
              resultArray.list.push({"url" : url , "month" : month});
              resultArray.array.push(url)
          }
        
        }
      }
    }
    
    function _getMonth( doc ) {
        var historyNode = doc.getElementById('r0');
        //if (!historyNode ) return null;
        var previousNode =  historyNode.previousSibling;
        var fullDate  =  previousNode.getElementsByTagName('b')[0].innerHTML;
        var month = fullDate.split(' ')[0];
        return month;   
    }


    function _exctractHistory( doc ) {
    _cout('Entered in extractHostory')
        extractHistoryFromDoc(doc);
        var hist =  JSON.stringify(resultArray);
        _writeHistfile(hist)
    }
    
    
    
    function _getNext( doc ) {
        var  anchors_ = doc.getElementsByTagName('a');
        for ( var i=0; i <  doc.getElementsByTagName('a').length; i++) {
            anch = doc.getElementsByTagName('a')[i];
             if ( (anch.innerHTML.indexOf('Newer')>=0 || anch.innerHTML.indexOf('Suivant')>=0) &&  anch.getAttribute('href').indexOf('./') ==0 )      {
                return (anch.getAttribute('href').substring(2) )
            }                 
        }   
    }
    
    
    function _exctractAccountName( doc ) {
        var accountStr = doc.querySelector("#gbmpdv .gbps2").textContent;
        return accountStr;
    }

    function _writeHistfile(hist) {   
         var hist_file = ADMONITOR.utils._getProfileDir().clone();
  	     hist_file.append("ADMONITOR");
         hist_file.append("History"); 
         if( !hist_file.exists() || !hist_file.isDirectory() ) 
  	   	     hist_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
  	   	 hist_file.append('hist.json');
         var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                         createInstance(Components.interfaces.nsIFileOutputStream);          
         foStream.init(hist_file, 0x02 |0x08 | 0x20 , 0666, 0); 
         var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
                                    createInstance(Components.interfaces.nsIConverterOutputStream);
         converter.init(foStream, "UTF-8", 0, 0);
         converter.writeString(hist);
         converter.close(); 
    }
    
    
    function _resumeFromHistfile() {   
         var hist_file = ADMONITOR.utils._getProfileDir().clone();
  	     hist_file.append("ADMONITOR");
         hist_file.append("History"); 
         if( !hist_file.exists() || !hist_file.isDirectory() ) 
  	   	     hist_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
  	   	 hist_file.append('hist.json');
  	   	 if (!hist_file.exists() ) {
            resultArray = {'list':[], 'array':[] }
            return;
          }
         var data = ADMONITOR.utils._getStringFromFile(hist_file);
          resultArray = JSON.parse(data);
          if (resultArray.start) startUrl = resultArray.start;
    }   
    
    


  return {    
  

      
      _getHistory :function() {
         _resumeFromHistfile();
          _cout(startUrl)
         var frame =  _initHistIFrame();
         alert("Click OK to start the History extraction")
         frame.contentDocument.location.href =  startUrl;
      },

  }
  
  
  
}();