// JavaScript Document
if (!ADMONITOR) var ADMONITOR = {};

ADMONITOR.adgraber= function() {

    var adg_categories= null;
    var adg_id = -1;
    var adg_file = null;
    var last_search = '';
  
    
    	        
    function _initAdGraberIFrame() {
	    var adg_frame = document.createElement("iframe"); // iframe or browser
	    adg_frame.setAttribute("id", "adgraber-frame");
  		adg_frame.setAttribute("name", "adgraber-frame");
  		adg_frame.setAttribute("type", "content");
  		adg_frame.style.setProperty('min-height', "0px", 'important');
  		adg_frame.style.setProperty('height', "0px", 'important');
  		document.getElementById("main-window").appendChild(adg_frame);
      adg_frame.docShell.allowAuth = true;
  		adg_frame.docShell.allowImages = true;
  		adg_frame.docShell.allowJavascript = true;
  		adg_frame.docShell.allowMetaRedirects = true;
  		adg_frame.docShell.allowPlugins = true;
  		adg_frame.docShell.allowSubframes = true;
  		
  		adg_frame.addEventListener("load", function (event) {
    		var frame = document.getElementById("adgraber-frame")  		
    		var doc = event.originalTarget;
  
    		if (doc.location.href == "about:blank" || doc.defaultView.frameElement) return;     
        var ad = _exctractAd(doc);
        if (ad == null)  {
          adg_str = "";
        } else { 
      		adg_str += ad;
      		adg_str += _setAdFooter();
      	}
    		_writeAdfile()
  		}, true); 
      
      return adg_frame;   	        
    } 
    
    
    function _cout(msg) {
      //	ADMONITOR.utils._cout(msg);
  	} 
  	
  	
  	function extractAdFromElt ( cont ) {
        var ad_container = cont.parentNode.parentNode.parentNode;
        return ad_container.innerHTML.replace(/(<([^>]+)>)/ig,'');    
    }
  	
  	function extractAdFromGoogle(doc) {
  	    var ad_str = '';
        var elt = doc.getElementById('an1');
        if (elt != null) 
          ad_str += extractAdFromElt(elt);  
        elt = doc.getElementById('pa1');
        if (elt != null) 
          ad_str += extractAdFromElt(elt);  
        return ad_str;
    }
    
        
    function extractAdFromDoc(doc,adClasses) {
        var ad_str = '';
        var divs = doc.getElementsByTagName('div');
        for ( var i = 0; i< divs.length; i++)  {
             var div = divs[i];
             if ( div.hasAttribute('class') && adClasses.indexOf(div.getAttribute('class')) >=0) {
                var adTitles = div.getElementsByTagName('h2');
                for( var j=0; j< adTitles.length; j++)
                   adTitles[j].innerHTML = '';
                ad_str += div.innerHTML.replace(/(<([^>]+)>)/ig,''); 
              }
        }
        return ad_str;
    }
    
            
    function extractAdFromAOL(doc) {
        return '';
    }





    function _exctractAd( doc,engine ) {
        var  ad_str = '';
        switch ( engine ) {
          case 'google' :
            ad_str = extractAdFromGoogle(doc);
            break;
          case 'yahoo' :
            ad_str += extractAdFromDoc(doc,["ads horiz ","ads horiz bot","ads"]);
            break;
          case 'bing' :
            ad_str += extractAdFromDoc(doc,["sb_adsWv2","sb_adsWv2 sb_adsW2v2","sb_adsNv2"]);
            break; 
          case 'aol' :
            break; 
        }  
        if (ad_str == '') return null;
        return ad_str;   
    }
    


    function _writeAdfile(adg_str) {
         var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                         createInstance(Components.interfaces.nsIFileOutputStream);          
          foStream.init(adg_file, 0x02 | 0x08 | 0x20, 0666, 0); 
          var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
                                    createInstance(Components.interfaces.nsIConverterOutputStream);
          converter.init(foStream, "UTF-8", 0, 0);
          converter.writeString(adg_str);
          converter.close(); 
    }
    
    function _getAdForCategory(id, ad_name)  {
          adg_str = _setAdHeader(ad_name); 
          var ad_frame = document.getElementById("adgraber-frame") 
          if ( !ad_frame ) ad_frame = _initAdGraberIFrame();
          ad_frame.contentDocument.location.href =  "http://www.google.com/search?q="+ad_name.replace('&','');             
    }
    
    function _setAdHeader (ad_name) {
        var header = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'
        header+= '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-us" lang="en-us" >'
        header+='<head><title>'+ ad_name +'</title><head><body>'
        return header; 
    }
    
    function _setAdFooter () {
        var footer = '</body></html>'
        return footer; 
    }
    
          
      function _exctractGoogleAccountName ( doc ) {
        var  accountElt = doc.getElementById("guser");
        if (!accountElt) {
             var subframes = doc.getElementsByTagName('iframe');
             for (var i=0; i < subframes.length; i++) {
              var tempId = _exctractGoogleAccountName(subframes[i].contentDocument);
              if (tempId != 'NotSignIn') return tempId;
            }
            return 'NotSignIn';
        }
        try {
          var accountStr = accountElt.getElementsByTagName('b')[0].innerHTML;
        }catch(ex) {return 'NotSignIn';} 
        return accountStr;
      }
      
      function _exctractHistoryAccountName ( doc ) {
        var  accountElt = doc.getElementsByTagName("tbody")[0];
        if (!accountElt) return 'NotSignIn';
        try {
          var accountStr = accountElt.getElementsByTagName('b')[0].innerHTML;
          if (accountStr.indexOf('@gmail') <= 0) return 'NotSignIn'; 
        }catch(ex) {return 'NotSignIn';} 
        return accountStr;
      }
      
      function  _exctractYahooAccountName ( doc ) {
        var  accountElt = doc.getElementById("uh");
        if (!accountElt) return 'NotSignIn';
        try {
          var accountStr = accountElt.getElementsByTagName('strong')[0].innerHTML;
        }catch(ex) {return 'NotSignIn';} 
        if (accountStr == 'Guest') return 'NotSignIn';
        return accountStr+'@yahoo.com';
      }
      
      function  _saveAd ( ad ) {
          adg_file = ADMONITOR.utils._getProfileDir().clone();
  	      adg_file.append("ADMONITOR");
          adg_file.append("GoogleAdWords"); 
          if( !adg_file.exists() || !adg_file.isDirectory() ) 
  	   	     adg_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
          adg_file.append(ADMONITOR.adgraber._exctractAccountName(doc)); 
          if( !adg_file.exists() || !adg_file.isDirectory() ) 
  	   	    adg_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);          
          if (ad == null )  adg_file.append('Empty ad for ' + doc.title.toString()+ time.getTime().toString());
          else  adg_file.append(doc.title+ time.getTime().toString());
          _writeAdfile(ad);
        }
        
        function _classifyAd( ad ) {
          if (!ad) return null;
          var adText =  ad.replace(/(<([^>]+)>)/ig," ").replace(/&nbsp;/ig," ").replace(/&amp;/ig," ").split(/\W/g).map(String.toLowerCase);
          var best_cats = ADMONITOR.delicious._bestCats( adText );      
      	  if ( best_cats == null ) return null;
	        else {
            var p_categories = [];
            best_cats.map( function(a){ return ADMONITOR.delicious._getHierachyArray(a[0],p_categories); }) ;      	       
  	        _cout( "Categories assigned to the ad are : " + p_categories);	  
            var vector = ADMONITOR.delicious._categoriesToVector(p_categories);  
            ADMONITOR.accmanager._updateCurrentAdVector(vector);   
  	        return p_categories;  
          }
        }

  return {    
  
     _getAds :  function() {
         var id_file, ad_name="", broke = false, id = -1; 
         var adfile = ADMONITOR.utils._getProfileDir().clone();
	       adfile.append("ADMONITOR");
         adfile.append("GoogleAdWords"); 
         if( !adfile.exists() || !adfile.isDirectory() ) 
	   	     adfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
         if (adg_categories == null) adg_categories= ADMONITOR.delicious._getCategoryArray();
         for each( var elt in adg_categories) {
            id = elt["id"];   
            adg_file = adfile.clone();
            adg_file.append(id+".html");
            if (!adg_file.exists() )  {
                broke = true; 
                break;            
            }        
         }           
         if (broke) {
              adg_id = id;
              ad_name = elt["name"]; 
              _cout("Getting ad for id "+ id +" with name "+ad_name );
              _getAdForCategory(id, ad_name);   
              setTimeout(ADMONITOR.adgraber._getAds, 120000*Math.random() );
              return;   
          }    
      },
      
      _exctractAccountName : function( doc, engine) {
        if( engine == null || engine == 'google' || engine == 'gmail' || engine =='googledoc' )    {
            var account = _exctractGoogleAccountName(doc);
            //if ( account == 'NotSignIn') account =  _exctractHistoryAccountName(doc);
            return  account;
        }
        if (engine == 'yahoo')  
            return _exctractYahooAccountName(doc);
      },
      

      
      _getAdForDoc : function(doc, action_) {
           var url = doc.location.href;   
           var engine = ADMONITOR.accmanager._getEngineFromUrl(url);           
           if ( !engine) return;
           var time = new Date(); 
           var ad = _exctractAd(doc,engine ); 
           last_search = doc.title; 
           switch (action_) {
             case 'save': 
                _saveAd( ad );
                break; 
             case 'classify': 
                var adCats = _classifyAd( ad );
                _cout( adCats );
                break;   
            }
            return;      
      },
      
      _getAdForEvt :function() {
         var doc = window.content.document;
         ADMONITOR.adgraber._getAdForDoc(doc,'classify' );
      },

  }
  
  
  
}();

        /*var ads = ad_container.getElementsByTagName("li");
        for each (var ad in ads) {
            var cite = 'http://'+ad.getElementsByTagName("cite")[0].innerHTML
                         .replace(/(<([^>]+)>)/ig,'');
            var anch= ad.getElementsByTagName("a")[0] ;
            anch.setAttribute("href",cite);
        } */