
                          
if (!ADMONITOR) var ADMONITOR = {};


ADMONITOR.init= function() {
	
	var cc = null;
	var ci = null;
	var i_configfile = null;
	var i_is_init = false;


	function _isRunning()	{
	  try {
  		if( !ADMONITOR.utils._isWindowType("navigator:browser") )
  			return true;
  	} catch (ex) { /*Probably we're reloading the window*/
  	    return false;
    }
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
							getService(Components.interfaces.nsIWindowMediator);
		var en = wm.getEnumerator("navigator:browser");
		 while (en.hasMoreElements()) { 
	      var win = en.getNext(); 
	      if (win.ADMONITOR.init && win.ADMONITOR.init._isInit() ) 
	      	return true;
	    }
	    return false
    }
    
    function _getRunningWindow() {
    		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    							getService(Components.interfaces.nsIWindowMediator);
    		var en = wm.getEnumerator("navigator:browser");
    		 while (en.hasMoreElements()) { 
    	      var win = en.getNext(); 
    	      if (win.ADMONITOR.init && win.ADMONITOR.init._isInit() ) 
    	      	return win;
    	    }
	    return null;
    }  
    
        
     function  addToListener(obj){
          var observerService = Components.classes["@mozilla.org/observer-service;1"].
            getService(Components.interfaces.nsIObserverService);
          observerService.addObserver(obj, "http-on-modify-request", false);
          observerService.addObserver(obj, "http-on-examine-response", false);
    }
        
    function removeFromListener(obj){
       var observerService = Components.classes["@mozilla.org/observer-service;1"].
          getService(Components.interfaces.nsIObserverService);
       observerService.removeObserver(obj, "http-on-modify-request");
       observerService.removeObserver(obj, "http-on-examine-response");
    }
    
    
    function _removeLoadingEventListener(win_) {        
        win_.removeEventListener("click", ADMONITOR.init._incrementClicks, true);
        win_.removeEventListener("unload", ADMONITOR.init.unLoad, false);
    } 
	
	

	
	return {

	
        
      
      observe: function(oHttp, aTopic, aData)
      { 
       	if (  aTopic =='http-on-examine-response'  ) {
             var httpChannel = oHttp.QueryInterface(Components.interfaces.nsIHttpChannel);
            ADMONITOR.network._onIncomingResponse(oHttp);
    	 	}
    	 	if (aTopic == "http-on-modify-request" ) {
    	       var httpChannel = oHttp.QueryInterface(Components.interfaces.nsIHttpChannel);    	       
 	   	 		  ADMONITOR.network._onOutgoingRequest(oHttp);				 
    	 	}
      },
      	  
 
	    
	        
    onLoad: function() { 
	    if ( _isRunning() ) 
        return;
      var wins = ADMONITOR.init._getWindows();
      for (var i = 0;i < wins.length; i++)
            wins[i].ADMONITOR.init._addADMONITORLoadingEventListener();     
	    i_is_init = true;
	    
	    cc = Components.classes;
	    ci = Components.interfaces;
	    ADMONITOR.accmanager._init();

	    i_configfile = ADMONITOR.utils._getProfileDir().clone();
	    i_configfile.append("ADMONITOR");
	    if( !i_configfile.exists() || !i_configfile.isDirectory() )    // if it doesn't exist, create    ADMONITOR.accmanager._resultPageHandlerEvt
	   		i_configfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	   			 	
  	 	ADMONITOR.delicious._decodeBytesFromRunFile();
      //window.addEventListener("load", function () { 
        //gBrowser.addEventListener("load", function(x){alert('test');},true, true);
       // gBrowser.addEventListener("load", ADMONITOR.adgraber._getAdForEvt, true);
      //},  false); 
  	 	var prefs = ADMONITOR.utils._getPrefs();
      addToListener(this);	 	
	 },
	 

	  _getWindows: function (){
          try {
            var windows =  new Array(); 
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    							              getService(Components.interfaces.nsIWindowMediator);
    	     	var en = wm.getEnumerator("navigator:browser");
            while (en.hasMoreElements()){ 
              var win = en.getNext(); 
              if (win)windows.push(win);
            }
            return windows;
          } 
          catch(e){ cerr("getWindows(): ",e); }
    },
        
	 
    _addADMONITORLoadingEventListener : function () {
        window.addEventListener("load", function() {ADMONITOR.init.onLoad();}, false);
       // window.addEventListener("load",
       //       function  (){
       //            gBrowser.addEventListener("load", ADMONITOR.accmanager._resultPageHandlerEvt, false);
       //            gBrowser.addEventListener("load", ADMONITOR.adgraber._getAdForEvt, false);
       //       }, false);   
        window.addEventListener("unload", ADMONITOR.init.unLoad, false);
    },
        
	 
	 _isInit : function() {
		 return i_is_init;
	 },
	 
	 
	 _getConfigFile : function() {
		 return i_configfile;
	 },
       
	 _inBannerHistory : function(url) {
        var idx = i_banner_history.indexOf(url);                
        if (idx < 0) return false;
        return i_banner_history[idx];

      },
      
   _processProfiling : function(e) {
      var win = _getRunningWindow();
      win.ADMONITOR.profiler._processProfiling(e);
    },
    
    _updateTimeEnd : function() {
       var win = _getRunningWindow();
       win.ADMONITOR.profiler._updateTimeEnd();
    },
    
    _updateTimeStart : function(e) {
        var url = e.currentTarget.contentDocument.location.href;
        var win = _getRunningWindow();
        win.ADMONITOR.profiler._updateTimeStart(url);
    },
    
    _incrementClicks : function (e) {
       var win = _getRunningWindow();
       win.ADMONITOR.profiler._incrementClicks(e);
    },
    
  
    

    
    
    _render : function (e) {
       var win = _getRunningWindow();
       win.ADMONITOR.rendering._render(e);
    },
    
    unLoad : function() {
        if (!i_is_init ) return;
        i_is_init = false;
        //Application.storage.set('ADMONITORSave', true);
      	var lastGood = -1;
      	ADMONITOR.accmanager._saveAccounts();
        var wins = ADMONITOR.init._getWindows();
        for (var i = 0;i < wins.length; i++)
            if (wins[i]) {
                  lastGood = i;
                  _removeLoadingEventListener(wins[i])
            }
        if (lastGood > -1 && wins[lastGood])  {
          //ADMONITOR.delicious._saveData();
          wins[lastGood].ADMONITOR.init.onLoad();
        }           
    },
	 

		}
}();





//window.addEventListener("load", ADMONITOR.profiler.onLoad, false);
try {
  ADMONITOR.init._addADMONITORLoadingEventListener();  
} catch (ex) {/* Not good type*/}




  
