if (!ADMONITOR) var ADMONITOR = {};


ADMONITOR.network= function() {
  var ci = Components.interfaces;
  
  
  var regexMap = {
          google : ".*?q=([^&]*)(.*)$",      
          yahoo :  ".*?p=([^&]*)(.*)$",
          bing : ".*?q=([^&]*)(.*)$",
          aol : ".*?q=([^&]*)(.*)$",
          ask : ".*?q=([^&]*)(.*)$"
  };
	

  function _cout(msg) {
    	ADMONITOR.utils._cout(msg);
	} 


	function _isAnAdUrl ( x, str_host ) {
	      var regex =  new RegExp(x,'g')
        return regex.test(str_host)
   }

     function _getDocIdForHttpChannel(httpChannel) {// source of the function : http://forums.mozillazine.org/viewtopic.php?p=2774976           
        var notificationCallbacks = httpChannel.notificationCallbacks ? httpChannel.notificationCallbacks : httpChannel.loadGroup.notificationCallbacks;
         
        if ( notificationCallbacks ) {
            try {
               return notificationCallbacks.getInterface(ci.nsIDOMWindow).document;
             } catch (ex) {
                 return null
             }
        }
        else {
         return(doc);
       }
     }


     function removeDuplicateKey(cookie_) {
        var result = '';
        var values = cookie_.split(';');
        var previous_keys = [];
        for each(var val in values) {
            var key = val.split('=')[0];
            if  (previous_keys.indexOf(key)<0) {
                 //_cout('Val ' + val + 'current key '+ key);
                 previous_keys.push(key); 
                 result += val +';'
            }
        }
        return result;
     }
     
     function getCategoriesForSearch( url, engine ) {
          var sch = url.split("?")[1];;
          var regex = new RegExp(regexMap[engine],"g");
      		regex.exec(sch);
      		var queries = RegExp.$1.split('+');	
          var best_cats = ADMONITOR.delicious._bestCats( queries );      
      	  if ( best_cats == null ) return null;
	        else {
	          var p_categories = [];
            best_cats.map( function(a){ return ADMONITOR.delicious._getHierachyArray(a[0],p_categories); }) ; 
            //var p_categories = best_cats.map( function(a){ return ADMONITOR.delicious._getHierachy(a[0]); }) ;      	       
  	       // _cout( "Categories assigned to " + url + " are : " + p_categories);	  
            var vector = ADMONITOR.delicious._categoriesToVector(p_categories);  
            ADMONITOR.accmanager._updateCurrentSearchVector(vector);        
  	        return p_categories;  
          }  
     
     }

return {

    
    _onIncomingResponse: function(oHttp){  
        var url = oHttp.URI.asciiSpec;
        var engine = ADMONITOR.accmanager._getEngineFromUrl(url);   
        var cookie_ = '';           
        if ( engine ){
            var httpChannel = oHttp.QueryInterface(Components.interfaces.nsIHttpChannel);
            try{
                cookie_ = httpChannel.getResponseHeader('Set-Cookie');
               //_cout('Response header : ' + cookie_);
                ADMONITOR.accmanager._setCookieForUpdate(cookie_);
            } catch(ex){}
            var doc = _getDocIdForHttpChannel(httpChannel);
            var brows = gBrowser.getBrowserForDocument(doc);
            if( brows) {
              brows.addEventListener("load", ADMONITOR.accmanager._resultPageHandlerEvt, true);
              brows.addEventListener("load", ADMONITOR.adgraber._getAdForEvt, true);
            }
        }         
    },

            
    _onOutgoingRequest : function(oHttp){    
        var url = oHttp.URI.asciiSpec;
        var host = oHttp.URI.host;         
        var engine = ADMONITOR.accmanager._getEngineFromUrl(url);              
        if ( engine ){    
              var categories = getCategoriesForSearch( url, engine);
              if ( ADMONITOR.accmanager._modifyCookie() ) {  
                 oHttp.setRequestHeader('Cookie','',false) 
              } else {
                var sent_cookie = removeDuplicateKey(oHttp.getRequestHeader('Cookie') );
                oHttp.setRequestHeader('Cookie',sent_cookie,false) 
              }
              //_cout('Send Cookie: ' + oHttp.getRequestHeader('Cookie') );
          }
    },

  
  }
   
   
  }();  